// To compile : g++ -o arrays.exe arrays.cpp
#include <iostream>

int compute_factorial(int N) {
  int i;
  int factorial = 1;

  for (i=1; i<N+1; i++) factorial *= i;

  return factorial;
}


int main()
{
  int i;
  int N;
  int *values;

  std::cout << "N : ";
  std::cin >> N;
  
  if (N >= 0) {
    std::cout << "values (before allocation) : " << values << std::endl;
    
    values = new int[N+1];
    std::cout << "values (after allocation)  : " << values << std::endl;

    for (i=0; i<N+1; i++) values[i] = compute_factorial(i);
    for (i=0; i<N+1; i++) std::cout << i << "! : " << values[i] << std::endl;
    
    delete[] values;
    std::cout << "values (after deallocation)  : " << values << std::endl;
  }

  return 0;
}
