// To compile : g++ -o pointers.exe pointers.cpp
#include <iostream>

int main() {
  int i=0, j=1;
  int *iptr = &i;

  std::cout << "iptr  : " << iptr  << std::endl;
  std::cout << "i     : " << i     << std::endl;
  std::cout << "*iptr : " << *iptr << std::endl;
  std::cout << "&i    : " << &i    << std::endl;
  std::cout << "&j    : " << &j    << std::endl;

  i = 10;
  std::cout << "iptr  : " << iptr  << std::endl;
  std::cout << "i     : " << i     << std::endl;
  std::cout << "*iptr : " << *iptr << std::endl;
  std::cout << "&i    : " << &i    << std::endl;
  std::cout << "&j    : " << &j    << std::endl;

  *iptr = 20;
  std::cout << "iptr  : " << iptr  << std::endl;
  std::cout << "i     : " << i     << std::endl;
  std::cout << "*iptr : " << *iptr << std::endl;
  std::cout << "&i    : " << &i    << std::endl;
  std::cout << "&j    : " << &j    << std::endl;

  iptr = &j;
  std::cout << "iptr  : " << iptr  << std::endl;
  std::cout << "i     : " << i     << std::endl;
  std::cout << "*iptr : " << *iptr << std::endl;
  std::cout << "&i    : " << &i    << std::endl;
  std::cout << "&j    : " << &j    << std::endl;
    
  return 0;
}
