#include "Star.h"


static const float Gconst = 1.0f;


//-----------------------------------------------------------------------------
class Nbody {

 public:
  int Nstar;
  float epsilon;
  Star* stardata;

  Nbody(int);
  virtual ~Nbody();

  virtual void IntegrationStep(float) = 0;

  void CalculateAccelerations(void);

};


//-----------------------------------------------------------------------------
class NbodyEuler : public Nbody {

 public:
  NbodyEuler(int);

  virtual void IntegrationStep(float);

};
