#include <math.h>
#include "Vector.h"


Vector::Vector() 
{
  for (int k=0; k<3; k++) v[k] = 0.0f;
}


Vector::~Vector()
{
}


float Vector::Magnitude()
{
  int k;
  float magsqd = 0.0f;
  for (k=0; k<3; k++) magsqd += v[k]*v[k];
  return sqrtf(magsqd);
}


Vector Vector::UnitVector(void)
{
  int k;
  float mag = Magnitude();
  Vector unitVector;
  for (k=0; k<3; k++) unitVector.v[k] = v[k] / mag;
  return unitVector;
}
