// To compile : g++ -o Vector.exe Vector.cpp main.cpp
#include <iostream>
#include "Vector.h"

float dot_product(Vector a, Vector b) {
  float result = 0.0;
  for (int k=0; k<3; k++) result += a.v[k]*b.v[k];
  return result;
}

int main()  {
  Vector v1, v2;
  v1.v[0] = 2.0f;  v1.v[1] = 0.0f;  v1.v[2] = 3.0f;
  v2.v[0] = 4.0f;  v2.v[1] = 2.0f;  v2.v[2] = 1.0f;

  std::cout << "Dot product : " << dot_product(v1, v2) << std::endl;

  return 0;
}
